unit laztest2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, ZConnection, ZDataset, ZSqlMonitor, Forms,
  Controls, Graphics, Dialogs, StdCtrls, DBGrids, DbCtrls ;


type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Label5: TLabel;
    Loeschen: TButton;
    Label2: TLabel;
    Label3: TLabel;
    NeueDS: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    NeuerDS: TButton;
    Datasource1: TDatasource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    Label4: TLabel;
    Suche: TEdit;
    Leere: TButton;
    Fuelle: TButton;
    Memo1: TMemo;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZSQLMonitor1: TZSQLMonitor;
    procedure Button1Click(Sender: TObject);
    procedure DBEdit1Exit(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: char);
    procedure Edit3Enter(Sender: TObject);
    procedure Edit3Exit(Sender: TObject);
    procedure Edit3KeyPress(Sender: TObject; var Key: char);
    procedure Edit4Enter(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Edit4KeyPress(Sender: TObject; var Key: char);
    procedure FuelleClick(Sender: TObject);
    procedure LeereClick(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure NeueDSClick(Sender: TObject);
    procedure NeuerDSClick(Sender: TObject);
    procedure SucheEnter(Sender: TObject);
    procedure SucheExit(Sender: TObject);
    procedure SucheKeyPress(Sender: TObject; var Key: char);
    procedure SucheKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure gruen;
    procedure gelb;

  private
    { private declarations }
  public

    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.gruen;
begin
     edit1.Color:= $80FF55;
     edit2.Color:= $80FF55;
     edit3.Color:= $80FF55;
     edit4.Color:= $80FF55;
end;


procedure TForm1.gelb;
begin
   Edit1.color:=$55CCC4FD;
   Edit2.color:=$55CCC4FD;
   Edit3.color:=$55CCC4FD;
   Edit4.color:=$55CCC4FD;
end;


procedure TForm1.LeereClick(Sender: TObject);
begin
  ZQuery1.Close;
end;

procedure TForm1.NeueDSClick(Sender: TObject);

    var a : integer;
    var b : integer;
    var c : integer;
    var d : integer;
    var za : integer;

  Begin

  randomize;

  za := 1;
  While za <100  DO
  Begin;
  za := za + 1 ;

  a := random(100000)+1;
  b := random(100000)+1;
  c := random(100000)+1;
  d := random(100000)+1;


  With ZQuery1 do
  begin
      SQL.Clear;
      SQL.Text := 'INSERT INTO tabelle1 ';
      SQL.Add('Values (:Column1 , :Column2, :Column3, :Column4)');   //, :Column6)');
      ParamByName('Column1').AsString := 'X'+ inttostr(a) ;
      ParamByName('Column2').AsString := 'Y'+inttostr(b);
      ParamByName('Column3').AsString := inttostr(c);
      ParamByName('Column4').AsString := 'Z'+inttostr(d);
  //    Params.ParamValues['Column4'] := 'Z'+inttostr(d);
      ApplyUpdates;
      ExecSQL;
  end;

end;

end;

procedure TForm1.NeuerDSClick(Sender: TObject);

  var
  such : string;
  beispiel : string;

Begin

edit1.Text := Trimleft(edit1.Text);
edit2.Text := Trimleft(edit2.Text);
edit3.Text := Trimleft(edit3.Text);
edit4.Text := Trimleft(edit4.Text);

if edit1.Text = '' then
  begin
    edit1.SetFocus ;
    exit;
   end;

if edit2.Text = '' then
  begin
      edit2.SetFocus ;
      exit;
  end;

if edit3.Text = '' then
  begin
  edit3.SetFocus ;
  exit;
    end;

if edit4.Text = '' then
  begin
  edit4.SetFocus ;
  exit;
  end;

With ZQuery1 do
begin
    SQL.Clear;
    SQL.Text := 'INSERT INTO tabelle1 ';
    SQL.Add('Values (:Co1 , :Colu2, :Column3, :Column4)');  // , :Column6)');
    ParamByName('Co1').AsString := Edit1.Text;
    ParamByName('Colu2').AsString := Edit2.Text;
    ParamByName('Column3').AsString := Edit3.Text;
//    ParamByName('Column4').AsString := Edit4.Text;
    Params.ParamValues['Column4'] := Edit4.Text;
    ApplyUpdates;
    ExecSQL;
end;


With ZQuery1 do
begin
     SQL.Clear;
     SQL.Add('SELECT * FROM tabelle1');
     SQL.Add('WHERE Column1 LIKE :Eing1b');
     SQL.Add('AND Column2 LIKE :Eing2b');
     SQL.Add('ORDER BY Column1');
     Params.ParamValues['Eing1b'] := Edit1.Text;
     Params.ParamValues['Eing2b'] := Edit2.Text;
     Open;
end;


//    ZQuery1.SQL.Text := Memo1.Lines.Text;
//    ZQuery1.Open;

    {
With ZQuery1 do
begin
     SQL.Add('SELECT * FROM tabelle1');
     SQL.Add('WHERE Column1 LIKE :Eing1b');
     SQL.Add('AND Column2 LIKE :Eing2b');
     SQL.Add('ORDER BY Column1');
     ParamByName('Eing1b').AsString := Edit1.Text;
     ParamByName('Eing2b').AsString := Edit2.Text;


//     Params.ParamValues['Eing1'] := Edit1.Text;
//     Params.ParamValues['Eing2'] := Edit2.Text;
     Open;
end;

  }

// ZQuery1.SQL.Text := 'SELECT * FROM tabelle1 WHERE Column1 LIKE "%" ORDER BY Column1 ';
// ZQuery1.Open;

Edit1.Text := '';
Edit2.Text := '';
Edit3.Text := '';
Edit4.Text := '';

edit1.SetFocus ;

end;

procedure TForm1.SucheEnter(Sender: TObject);
begin
  Suche.text := '';
  Suche.Color:= $80FF55;
end;

procedure TForm1.SucheExit(Sender: TObject);
begin
Suche.text := '';
Suche.Color:= $55CCC4FD;
end;


procedure TForm1.SucheKeyPress(Sender: TObject; var Key: char);
begin
 If (key in [#13]) then
 begin
 dbgrid1.SetFocus;
 // Edit1.text := '*';
 end;
 IF NOT (Key IN [#8,#13,#32,#44,#48..#57,#64..#90,#97..#122,#186..#255]) then Key := #0;
end;

procedure TForm1.SucheKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);

Var
   Eing1 : string;
   Eing1a : string;
   Eing2 : string;
   Such : string;
   i : integer;

begin

 Eing1 := Suche.Text;
 Eing2 := Suche.Text;

 i := Pos(' ',Eing1);

 if i = 0 then
 BEGIN
   i := Pos(',',Eing1);
 END;

 if i > 0 then
 BEGIN
   Delete(Eing1,i,100);
   Eing2 := Copy(Eing2,i+1,100);
 END;

 if i = 0 then
 BEGIN
   Eing2 := '';
 END;
 Eing1a := Eing1;
 Eing1 := Eing1 + '%';
 Eing2 := Eing2 + '%';

 With ZQuery1 do
 Begin
     SQL.Clear;
     SQL.Add('SELECT * FROM tabelle1');
     SQL.Add('WHERE Column1 LIKE :Eing1');
     SQL.Add('AND Column2 LIKE :Eing2');
     SQL.Add('ORDER BY Column1');
     Params.ParamValues['Eing1'] := Eing1;
     Params.ParamValues['Eing2'] := Eing2;
     Open;

   //  Listbox1.AddItem.;

 end;

 Label1.Caption:= Eing1 + ' _ ' + Eing2;
 label3.Caption:= inttostr(ZQuery1.RecordCount);
 label4.Caption:= inttostr(i);

  if ZQuery1.RecordCount = 0 then
    begin
        ZQuery1.SQL.Text := Memo1.Lines.Text;
        ZQuery1.Open;
        suche.Text:='';
        edit1.text := Eing1a ;
        Edit1.SetFocus;
    end;


end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   Suche.SetFocus;
   Edit1.Text := '';
   Edit2.Text := '';
   Edit3.Text := '';
   Edit4.Text := '';
   ZQuery1.SQL.Text := Memo1.Lines.Text;
   ZQuery1.Open;

end;

procedure TForm1.DBEdit1Exit(Sender: TObject);


Var
   Urspr : string;

{
begin
  with ZQuery1 do

Close;
SQL.Clear;
SQL.Add('Update rltablo set bscname = :bscname, siteid = :siteid, sitename = :sitename where id = :recno');
          Parambyname('bscname').AsString:=Edit2.Text;
          Parambyname('siteid').AsString:=Edit3.Text;
          Parambyname('sitename').AsString:=Edit4.Text;
ExecSQL;
  }



begin

Urspr := 'Aaaneuneu';

with ZQuery1 do
 begin

SQL.Clear;
SQL.Add ('Update tabelle1 set Column1 = :Urspr WHERE (Column1 = :Column1) AND (Column2 = :Column2) AND (Column3 = :Column3) AND (Column4 = :Column4) ');

// SQL.Add('Values (:Column1 , :Column2, :Column3, :Column4, :Column6)');
//ParamByName('Column1').AsString := DBEdit1.Text;
//ParamByName('Column2').AsString := DBEdit2.Text;
//ParamByName('Column3').AsString := DBEdit3.Text;
// ParamByName('Column4').AsString := Edit4.Text;

Params.ParamValues['Urspr'] := Urspr;
Params.ParamValues['Column1'] := DBEdit1.Text;
Params.ParamValues['Column2'] := DBEdit2.Text;
Params.ParamValues['Column3'] := DBEdit3.Text;
Params.ParamValues['Column4'] := DBEdit4.Text;
// ApplyUpdates;
ExecSQL;

 end;

    ZQuery1.SQL.Text := Memo1.Lines.Text;
    ZQuery1.Open;


end;

// UPDATE `tabelle1` SET `Column2`='AY71644' WHERE  `Column1`='X30174' AND `Column2`='Y71644' AND `Column3`='66036' AND `Column4`='Z52791' LIMIT 1;
// UPDATE `tabelle1` SET `Column1`='AX51926' WHERE  `Column1`='X51926' AND `Column2`='Y89348' AND `Column3`='58021' AND `Column4`='Z64922' LIMIT 1;
// DELETE FROM `tabelle1` WHERE  `Column1`='X41851' AND `Column2`='Y48946' AND `Column3`='66813' AND `Column4`='Z15794' LIMIT 1;
// INSERT INTO `tabelle1` (`Column1`, `Column2`, `Column3`, `Column4`) VALUES ('X76344', 'Y79691', '72999', 'Z94488');
// SELECT  `Column1`,  `Column2`,  `Column3`,  `Column4` FROM `test`.`tabelle1` LIMIT 1000;
// DELETE FROM `tabelle1` WHERE  `Column1`='X14076' AND `Column2`='Y33117' AND `Column3`='57467' AND `Column4`='Z98957' LIMIT 1;


procedure TForm1.LoeschenClick(Sender: TObject);
begin
Label5.Caption:= DBEdit1.Text;   // Zur Kontrolle, ob der richtige String angewählt ist

// ZQuery1.SQL.Text:='DELETE FROM `tabelle1` WHERE  ( Column1 = " ' + DBEdit1.text + ' " )';

with ZQuery1 do
 begin
   SQL.Clear;
  //  SQL.add ( 'DELETE FROM `tabelle1` WHERE  ( Column1 = " ' + DBEdit1.text + ' " )');
   sql.Text := 'DELETE FROM `tabelle1` WHERE  Column1= :col1 ';
  //  Params.ParamValues['Col1'] := DBEdit1.Text;
   ParamByName('Col1').AsString := DBEdit1.Text;
  //  ApplyUpdates;
    ExecSQL;
 end;

ZQuery1.SQL.Text := Memo1.Lines.Text;  // alle Daten in der DBGrid nochmal anzeigen
ZQuery1.Open;

end;



procedure TForm1.FuelleClick(Sender: TObject);
begin

  try
  Begin
    ZQuery1.SQL.Text := Memo1.Lines.Text;
    ZQuery1.Open;
  end;
  except
       ShowMessage('Das ist Except in Query');
    exit;
  end;
  label3.Caption:= inttostr(ZQuery1.RecordCount);

end;



// <<<<<<


procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: char);
begin
   If (key in [#13]) then  Edit2.SetFocus;
   IF NOT (Key IN [#8,#13,#32,#44,#48..#57,#64..#90,#97..#122,#186..#255]) then Key := #0;
end;


procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: char);
begin
   If (key in [#13]) then  Edit3.SetFocus;
   IF NOT (Key IN [#8,#13,#32,#44,#48..#57,#64..#90,#97..#122,#186..#255]) then Key := #0;
end;


procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: char);
begin
   If (key in [#13]) then  Edit4.SetFocus;
   IF NOT (Key IN [#48..#57]) then Key := #0;
end;


procedure TForm1.Edit4KeyPress(Sender: TObject; var Key: char);
begin
   If (key in [#13]) then  NeuerDS.SetFocus;
   IF NOT (Key IN [#8,#13,#32,#44,#48..#57,#64..#90,#97..#122,#186..#255]) then Key := #0;
end;


procedure TForm1.Edit1Enter(Sender: TObject);
begin
   gruen;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
     gelb;
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
     gruen;
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
     gelb;
end;

procedure TForm1.Edit3Enter(Sender: TObject);
begin
     gruen;
end;

procedure TForm1.Edit3Exit(Sender: TObject);
begin
     gelb;
end;

procedure TForm1.Edit4Enter(Sender: TObject);
begin
     gruen;
end;

procedure TForm1.Edit4Exit(Sender: TObject);
begin
     gelb;
end;




// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

end.

// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

{
SQL.Add('SELECT * FROM tabelle1');
SQL.Add('WHERE Column1 LIKE :Eing1');
SQL.Add('AND Column2 LIKE :Eing2');
SQL.Add('ORDER BY Column1');
SQL.Add('Values (:Eing1 , :Eing2)');
ParamByName('Eing1').AsString := Eing1;
ParamByName('Eing2').AsString := Eing2;
Open; }




{ Such := 'SELECT * FROM tabelle1 WHERE Column1 LIKE "'+Eing1+'" AND Column2 LIKE "'+Eing2+'" ORDER BY Column1 ';
 ZQuery1.SQL.Text := Such ;
 ZQuery1. ;  }


